import pygame, time
from pygame.joystick import Joystick
from pygame.locals import *

LEFT, RIGHT, UP, DOWN, PUNCH, KICK = range(6)

class KeyState:
	def __init__(self):
		self.player1_queue = []
		self.player1_state = [0,0]
		self.player2_queue = []
		self.player2_state = [0,0]

	def update(self, event):
		time_stamp = time.time()
		if event.type == pygame.KEYDOWN:
			if event.key == K_w:
				self.player1_queue.append([UP, time_stamp])
			elif event.key == K_s:
				self.player1_queue.append([DOWN, time_stamp])
			elif event.key == K_a:
				self.player1_queue.append([LEFT, time_stamp])
				self.player1_state[LEFT] = 1
			elif event.key == K_d:
				self.player1_queue.append([RIGHT, time_stamp])
				self.player1_state[RIGHT] = 1
			elif event.key == K_f: self.player1_queue.append([PUNCH, time_stamp])
			elif event.key == K_g: self.player1_queue.append([KICK, time_stamp])
			elif event.key == K_UP: self.player2_queue.append([UP, time_stamp])
			elif event.key == K_DOWN: self.player2_queue.append([DOWN, time_stamp])
			elif event.key == K_LEFT:
				self.player2_queue.append([LEFT, time_stamp])
				self.player2_state[LEFT] = 1
			elif event.key == K_RIGHT:
				self.player2_queue.append([RIGHT, time_stamp])
				self.player2_state[RIGHT] = 1
			elif event.key == K_COMMA: self.player2_queue.append([PUNCH, time_stamp])
			elif event.key == K_PERIOD: self.player2_queue.append([KICK, time_stamp])
		if event.type == pygame.KEYUP:
		#	if event.key == K_w: self.player1[UP] = 0	
		#	elif event.key == K_s: self.player1[DOWN] = 0
			if event.key == K_a: self.player1_state[LEFT] = 0
			elif event.key == K_d: self.player1_state[RIGHT] = 0
		#	elif event.key == K_f: self.player1[PUNCH] = 0
		#	elif event.key == K_g: self.player1[KICK] = 0
		#	elif event.key == K_UP: self.player2[UP] = 0
		#	elif event.key == K_DOWN: self.player2[DOWN] = 0
			elif event.key == K_LEFT: self.player2_state[LEFT] = 0
			elif event.key == K_RIGHT: self.player2_state[RIGHT] = 0
		#	elif event.key == K_COMMA: self.player2[PUNCH] = 0
		#	elif event.key == K_PERIOD: self.player2[KICK] = 0
		elif event.type == pygame.JOYAXISMOTION:
			if event.joy == 0:
				if event.axis == 0 and event.value == 1:
					self.player1_queue.append([UP, time_stamp])
				elif event.axis == 0 and event.value == -1:
					self.player1_queue.append([DOWN, time_stamp])
				elif event.axis == 1 and event.value == 1:
					self.player1_queue.append([RIGHT, time_stamp])
					self.player1_state[RIGHT] = 1
				elif event.axis == 1 and event.value == -1:
					self.player1_queue.append([LEFT, time_stamp])
					self.player1_state[LEFT] = 1
				elif event.axis == 1 and event.value == 0:
					self.player1_state[RIGHT] = 0
					self.player1_state[LEFT] = 0
			elif event.joy == 1:
				button_pressed2 = 1
				if event.axis == 0 and event.value == 1:
					self.player2_queue.append([UP, time_stamp])
				elif event.axis == 0 and event.value == -1:
					self.player2_queue.append([DOWN, time_stamp])
				elif event.axis == 1 and event.value == 1:
					self.player2_queue.append([RIGHT, time_stamp])
					self.player2_state[RIGHT] = 1
				elif event.axis == 1 and event.value == -1:
					self.player2_queue.append([LEFT, time_stamp])
					self.player2_state[LEFT] = 1
				elif event.axis == 1 and event.value == 0:
					self.player2_state[RIGHT] = 0
					self.player2_state[LEFT] = 0
		elif event.type == pygame.JOYBUTTONDOWN:
			if event.joy == 0:
				button_pressed1 = 1
				if event.button == 0: self.player1_queue.append([PUNCH, time_stamp])
				elif event.button == 1: self.player1_queue.append([KICK, time_stamp])
				else: button_pressedi1 = 0
			elif event.joy == 1:
				button_pressed2 = 1
				if event.button == 0: self.player2_queue.append([PUNCH, time_stamp])
				elif event.button == 1: self.player2_queue.append([KICK, time_stamp])
				else: button_pressed2 = 0
	#	elif event.type == pygame.JOYBUTTONUP:
	#		if event.joy == 0:
	#			if event.button == 0: self.player1[PUNCH] = 0
	#			elif event.button == 1: self.player1[KICK] = 0
	#		if event.joy == 1:
	#			if event.button == 0: self.player2[PUNCH] = 0
	#			elif event.button == 1: self.player2[KICK] = 0

	#	if button_pressed1: self.player1_time = time.time()
	#	if button_pressed2: self.player2_time = time.time()
		if len(self.player1_queue) > 10: self.player1_queue = self.player1_queue[1:]
		if len(self.player2_queue) > 10: self.player2_queue = self.player2_queue[1:]

#	def update(self):
#		timestamp = time.time()
#		#for k in range(6): self.player1[k] = 0
#		#for k in range(6): self.player2[k] = 0
#		#p1 = [0, 0, 0, 0, 0, 0]
#		p1 = self.player1
#		p2 = [0, 0, 0, 0, 0, 0]
#		tmp = pygame.key.get_pressed()
#		if pygame.joystick.get_count() > 0:
#			j1up = Joystick(0).get_axis(0) > 0
#			j1down = Joystick(0).get_axis(0) < 0
#			j1left = Joystick(0).get_axis(1) > 0
#			j1right = Joystick(0).get_axis(1) < 0
#			j1b1 = Joystick(0).get_button(0)
#			j1b2 = Joystick(0).get_button(1)
#		else:
#			j1up = 0
#			j1down = 0
#			j1left = 0
#			j1right = 0
#			j1b1 = 0
#			j1b2 = 0 
#		if pygame.joystick.get_count() > 1:
#			j2up = Joystick(1).get_axis(0) > 0
#			j2down = Joystick(1).get_axis(0) < 0
#			j2left = Joystick(1).get_axis(1) > 0
#			j2right = Joystick(1).get_axis(1) < 0
#			j2b1 = Joystick(1).get_button(0)
#			j2b2 = Joystick(1).get_button(1)
#		else:
#			j2up = 0
#			j2down = 0
#			j2left = 0
#			j2right = 0
#			j2b1 = 0
#			j2b2 = 0 
#			
#		if tmp[K_w] or j1up:
#			if p1[UP] == 0:
#				self.player1_time = timestamp
#				p1[UP] = timestamp
#		else:
#			p1[UP] = 0
#		if tmp[K_s] or j1down:
#			if p1[DOWN] == 0:
#				self.player1_time = timestamp
#				p1[DOWN] = timestamp
#		else:
#			p1[DOWN] = 0
#		if tmp[K_a] or j1left:
#			if p1[LEFT] == 0:
#				self.player1_time = timestamp
#				p1[LEFT] = timestamp
#		else:
#			p1[LEFT] = 0
#		if tmp[K_d] or j1right:
#			if p1[RIGHT] == 0:
#				self.player1_time = timestamp
#				p1[RIGHT] = timestamp
#		else:
#			p1[RIGHT] = 0
#		if tmp[K_f] or j1b1:
#			if p1[PUNCH] == 0:
#				self.player1_time = timestamp
#				p1[PUNCH] = timestamp
#		else:
#			p1[PUNCH] = 0
#		if tmp[K_g] or j1b2:
#			if p1[KICK] == 0:
#				self.player1_time = timestamp
#				p1[KICK] = timestamp
#		else:
#			p1[KICK] = 0
#		if tmp[K_UP] or j2up: p2[UP] = 1
#		if tmp[K_DOWN] or j2down: p2[DOWN] = 1
#		if tmp[K_LEFT] or j2left: p2[LEFT] = 1
#		if tmp[K_RIGHT] or j2right: p2[RIGHT] = 1
#		if tmp[K_COMMA] or j2b1: p2[PUNCH] = 1
#		if tmp[K_PERIOD] or j2b2: p2[KICK] = 1
#
#		#for i in range(6):
#		#	if self.player1[i] == 0 and p1[i] > 0: self.player1_time = time.time()
#
#		for i in range(6):
#			if self.player2[i] == 0 and p2[i] == 1: self.player2_time = time.time()
#		self.player1 = p1
#		self.player2 = p2
