import pygame, time, sys, random
import gelarena, util
from pygame.locals import *


def do_menu(screen):
	bg_music = {'cherry': 'protofunk.ogg', 'lime': 'guitonsketch.ogg', 'bluerasberry': 'exotics.ogg', 'strawberry': 'feelinggood.ogg', 'blackberry': 'stylefunk.ogg'}
	ret_val = ["blackberry", "blackberry", "strawberry", 2]
	arrow = pygame.image.load("images/arrow.png")
	flavor = random.choice(["cherry", "lime", "bluerasberry", "strawberry", "blackberry"])
	bg = pygame.image.load("images/menu_" + flavor + ".png")
	arena = gelarena.GelArena(bg)
	pygame.mixer.music.load("sounds/" + bg_music[flavor])
	pygame.mixer.music.play(-1)
	pos = 0
	ok = 1
	while ok:
		for event in pygame.event.get():
			#if event.type == pygame.QUIT: sys.exit() #for now !!!
			if event.type == pygame.KEYDOWN and (event.key == K_w or event.key == K_UP) or event.type == pygame.JOYAXISMOTION and event.value == 1:
				if pos > 0: pos -= 1
			if event.type == pygame.KEYDOWN and (event.key == K_s or event.key == K_DOWN) or event.type == pygame.JOYAXISMOTION and event.value == -1:
				if pos < 2: pos += 1
			# if punch or kick select option with animation!!!
			if event. type == pygame.KEYDOWN and (event.key == K_f or event.key == K_g or event.key == K_COMMA or event.key == K_PERIOD) or event.type == pygame.JOYBUTTONDOWN and event.button < 2:
				arena.apply_force(pos*110 + 180, 150, 2)
				arena.apply_force(pos*110 + 180, 150, 3)
				ok = 0
				ret_val[3] = pos + 1
			
		screen.blit(bg, pygame.Rect(0,0, 640, 480))
		rect = pygame.Rect(185, pos*110 + 148, 64, 64)
		screen.blit(arrow, rect)
		pygame.display.flip()
	#animation
	ani_start = start = time.time()
	black = pygame.Surface((640,480)) #, SRCALPHA)
	arrow_x = 185
	while 1:
		pygame.event.pump()

		tmp = time.time()
		arena.update((tmp-start)*2.0)
		start = tmp
		
		arena.bg_blit(screen)
		ratio = ((tmp-ani_start)/3.0)
		if ratio > 1.0: ratio = 1.0
		
		rect = pygame.Rect(int(arrow_x + 1620*ratio), pos*110 + 148, 64, 64)
		screen.blit(arrow, rect)

		black.fill(pygame.Color(int((1-ratio)*255),int((1-ratio)*255),int((1-ratio)*255)))
		screen.blit(black, pygame.Rect(0,0, 640, 480), None, BLEND_MULT)
		pygame.display.flip()

		if tmp - ani_start >= 3.0:
			break
	
	if pos == 2: sys.exit()
	else:
		ret_val[:2] = do_select(pos+1, screen)
		ret_val[2] = random.choice(["cherry", "lime", "bluerasberry", "strawberry", "blackberry"])
		pygame.mixer.music.stop()
		return ret_val

def do_select(num_players, screen):
	if num_players == 2: return ["cherry", "cherry"]

	flavors = ["cherry", "lime", "bluerasberry", "strawberry", "blackberry"]
	flavor1 = select(1, flavors, screen)
	flavors.remove(flavor1)
	if num_players == 1:
		flavor2 = select(2, flavors, screen)
	else:
		#random flavor
		flavor2 = random.choice(flavors) 
	
	return [flavor1, flavor2]

def select(pnum, options, screen):
	keys = [[K_a, K_d, K_f, K_g], [K_LEFT, K_RIGHT, K_COMMA, K_PERIOD]]
	images = []
	for f in options:
		images.append(pygame.image.load("images/" + f + "_select.png"))
	
	start_image = 0
	end_image = 0
	
	screen.blit(images[start_image], pygame.Rect(0,0, 640, 480))
	util.fadein(screen, 1.0)

	while 1:
		if start_image == end_image:
			for event in pygame.event.get():
				if event.type == pygame.KEYDOWN and (event.key == keys[pnum-1][0]) or event.type == pygame.JOYAXISMOTION and event.joy == pnum-1 and event.axis == 1 and event.value == -1:
					if start_image > 0:
						end_image = start_image - 1
					else:
						end_image = len(images) - 1
					start = time.time()
				if event.type == pygame.KEYDOWN and (event.key == keys[pnum-1][1]) or event.type == pygame.JOYAXISMOTION and event.joy == pnum-1 and event.axis == 1 and event.value == 1:
					if start_image < len(images)-1:
						end_image = start_image + 1
					else:
						end_image = 0
					start = time.time()
				if event.type == pygame.KEYDOWN and (event.key == keys[pnum-1][2] or event.key == keys[pnum-1][3]) or event.type == pygame.JOYBUTTONDOWN and event.joy == pnum-1:
					util.fadeout(screen, 1.0)
					return options[start_image]
			
			screen.blit(images[start_image], pygame.Rect(0,0, 640, 480))
			pygame.display.flip()
		else:
			tmp = time.time()
			if end_image == 0 and start_image == len(images) - 1:
				change = 1
			elif end_image == len(images) -1 and start_image == 0:
				change = -1
			else:
				change = end_image - start_image
			ratio = (tmp - start)
			if ratio > 1.0: ratio = 1.0
			screen.blit(images[start_image], pygame.Rect(int(-change*ratio*640), 0, 640, 480))
			screen.blit(images[end_image], pygame.Rect(int(change*640 - change*ratio*640), 0, 640, 480))
			pygame.display.flip()

			if ratio >= 1.0 - 1e-5: start_image = end_image
			
			
