from keys import *
from consts import *



class Move:
	def __init__(self, mode, end_mode, damage, power, onfloor, accel, force, combo):
		self.mode = mode
		self.end_mode = end_mode
		self.onfloor = onfloor
		self.damage = damage
		self.power = power
		self.accel = accel
		mag = abs(float(force[0]*force[0] + force[1]*force[1]))
		if mag == 0: mag = 1
		self.force = [f/mag for f in force] # normalized. mag depends on power
		self.combo = combo
		self.last_key = [0,0]
	
	def reset(self):
		self.next_keys = 0
	
	def check_combo(self, key_state, direction):
		#tmp = len(self.combo[self.next_keys])
		#for key in self.combo[self.next_keys]:
		#	if k`ey_state[key]: tmp -= 1
		#keys = [0, 0, 0, 0, 0, 0]
		#for key in self.combo[self.next_keys]:
		#	keys[key] = 1

		#construct combo list
		num = -1
		for i in range(len(key_state)):
			if key_state[i] == self.last_key:
				num = i
				break

		#account for direction
		if direction >= 0:
			combo = self.combo
		else:
			combo = []
			for k in self.combo:
				if k == LEFT:
					combo.append(RIGHT)
				elif k == RIGHT:
					combo.append(LEFT)
				else:
					combo.append(k)

		queue = key_state[num+1:]
		
		if len(queue) < len(combo): return 0

		inputs = queue[-len(combo):]
		
		if inputs[0][0] != combo[0]: return 0
		
		for i in range(1,len(combo)):
			delay = inputs[i][1] - inputs[i-1][1]
			if inputs[i][0] != combo[i] or delay > 0.5:
				return 0

		#if tmp == 0:
		#if keys == key_state:
			#self.next_keys += 1
			#if self.next_keys >= len(self.combo):
		#		self.reset()
		#		return 1

		#made it to the end ... combo succeded
		self.last_key = key_state[-1]
		return 1

NO_MOVE = Move(0, 0, NONE, NONE, 0, [0,0], [0,0], []) # this work ???

class MoveList:
	def __init__(self, moves):
		self.moves = moves

	def check_combos(self, key_state, direction):
		ret_move = NO_MOVE
		found = 0
		for move in self.moves:
			if move.check_combo(key_state, direction) and len(move.combo) > len(ret_move.combo):
				found = 1
				ret_move = move
		if found: return ret_move
		else: return None
	
	def reset(self):
		for move in self.moves:
			move.reset()

def create_moves(flavor):
	if flavor == "blackberry": return create_blackberrymoves()
	elif flavor == "cherry": return create_blackberrymoves()
	elif flavor == "lime": return create_blackberrymoves()
	elif flavor == "bluerasberry": return create_blackberrymoves()
	elif flavor == "strawberry": return create_blackberrymoves()

def create_basicmoves():
	jump = Move(JUMP, 0, NONE, MEDIUM, 0, [0, 0], [0,1], [UP])
	jump1 = Move(JUMP, 0, NONE, HEAVY, 0, [0, 0], [0,1], [UP, UP])
	jump2 = Move(JUMP, 0, NONE, CRITICAL, 0, [0, 0], [0,1], [UP, UP, UP])
	jumpforward = Move(JUMP, 0, NONE, HEAVY, 0, [0, 0], [-1,1], [UP, RIGHT])
	jumpforward1 = Move(JUMP, 0, NONE, CRITICAL, 0, [0, 0], [-1,1], [UP, UP, RIGHT])
	jumpforward2 = Move(JUMP, 0, NONE, DEADLY, 0, [0, 0], [-1,1], [UP, UP, UP, RIGHT])
	jumpback = Move(JUMP, 0, NONE, HEAVY, 0, [0, 0], [1,1], [UP, LEFT])
	jumpback1 = Move(JUMP, 0, NONE, CRITICAL, 0, [0, 0], [1,1], [UP, LEFT])
	jumpback2 = Move(JUMP, 0, NONE, DEADLY, 0, [0, 0], [1,1], [UP, LEFT])
	punch = Move(PUNCH, 0, MEDIUM, LIGHT, 0, [0, 0], [1,0], [PUNCH])
	kick = Move(KICK, 0, LIGHT, MEDIUM, 0, [0, 0], [1,0], [KICK])
	block = Move(BLOCK, 0, NONE, NONE, 0, [0, 0], [1,0], [LEFT, LEFT])
	return [jump, jump1, jump2, jumpforward, jumpforward1, jumpforward2, jumpback, jumpback1, jumpback2, punch, kick, block]

def create_blackberrymoves():
	spc1 = Move(SPECIAL1, 0, DEADLY, MEDIUM, 0, [0,0], [0,1], [DOWN, PUNCH])
	spc2 = Move(SPECIAL2, 0, MEDIUM, MEDIUM, 0, [0,0], [1,0], [RIGHT, PUNCH])
	spc3 = Move(SPECIAL3, 0, HEAVY, HEAVY, 0, [0, 0], [1,1], [DOWN, RIGHT, PUNCH])
	specials = [] #[spc1, spc2, spc3]
	return MoveList(create_basicmoves() + specials)

def create_cherrymoves():
	spc1 = Move(SPECIAL1, 0, HEAVY, MEDIUM, 0, [0,0], [1,1], [UP, RIGHT, PUNCH])
	spc2 = Move(SPECIAL2, 0, MEDIUM, MEDIUM, 0, [0,0], [1,0], [RIGHT, RIGHT, PUNCH])
	spc3 = Move(SPECIAL3, 0, MEDIUM, HEAVY, 0, [0, 0], [1,0], [RIGHT, RIGHT, KICK])
	specials = [] #[spc1, spc2, spc3]
	return MoveList(create_basicmoves() + specials)

def create_limemoves():
	spc1 = Move(SPECIAL1, 0, NONE, NONE, 0, [0,0], [0,0], [LEFT, LEFT, PUNCH, KICK])
	spc2 = Move(SPECIAL2, 0, CRITICAL, LIGHT, 0, [0,0], [0,0], [LEFT, KICK, DOWN])
	spc3 = Move(SPECIAL3, 0, MEDIUM, MEDIUM, 0, [0, 0], [1,1], [LEFT, LEFT, PUNCH, PUNCH])
	specials = [] #[spc1, spc2, spc3]
	return MoveList(create_basicmoves() + specials)

def create_bluerasberrymoves():
	spc1 = Move(SPECIAL1, 0, HEAVY, HEAVY, 0, [70,-50], [70,-50], [RIGHT, UP, KICK, KICK])
	spc2 = Move(SPECIAL2, 0, MEDIUM, MEDIUM, 0, [0,0], [1,3], [KICK, UP, KICK])
	spc3 = Move(SPECIAL3, 0, LOW, CRITICAL, 0, [0, 0], [1,0], [RIGHT, RIGHT, KICK])
	specials = [] #[spc1, spc2, spc3]
	return MoveList(create_basicmoves() + specials)

def create_strawberrymoves():
	spc1 = Move(SPECIAL1, 0, MEDIUM, MEDIUM, 0, [0,0], [1,0], [UP, KICK])
	spc2 = Move(SPECIAL2, 0, LIGHT, LIGHT, 0, [0,0], [1,0], [PUNCH, PUNCH, PUNCH])
	spc3 = Move(SPECIAL3, 0, LIGHT, LIGHT, 0, [-30, 0], [1,1], [LEFT, KICK, KICK])
	specials = [] #[spc1, spc2, spc3]
	return MoveList(create_basicmoves() + specials)

