import pygame, time, sys
from pygame.locals import *

def fadeout(screen, t):
	old_screen = screen.copy()
	ok = 1
	black = pygame.Surface((640,480))
	start = time.time()
	while ok:
		pygame.event.pump()

		tmp = time.time()
		ratio = (tmp - start)/t
		if ratio > 1.0: ratio = 1.0
		black.fill(pygame.Color(int((1-ratio)*255),int((1-ratio)*255),int((1-ratio)*255)))
		screen.blit(old_screen, pygame.Rect(0,0, 640, 480))
		screen.blit(black, pygame.Rect(0,0, 640, 480), None, BLEND_MULT)
		pygame.display.flip()

		if tmp - start >= t:
			ok = 0

def fadein(screen, t):
	old_screen = screen.copy()
	ok = 1
	black = pygame.Surface((640,480))
	start = time.time()
	while ok:
		pygame.event.pump()

		tmp = time.time()
		ratio = (tmp - start)/t
		if ratio > 1.0: ratio = 1.0
		black.fill(pygame.Color(int((ratio)*255),int((ratio)*255),int((ratio)*255)))
		screen.blit(old_screen, pygame.Rect(0,0, 640, 480))
		screen.blit(black, pygame.Rect(0,0, 640, 480), None, BLEND_MULT)
		pygame.display.flip()

		if tmp - start >= t:
			ok = 0

def draw_bboxes(screen, sprite):
	colors = [pygame.Color(0,0,255, 128), pygame.Color(0,255,255, 128), pygame.Color(255,0,0, 128), pygame.Color(255,255,0, 128), pygame.Color(0,255,0, 128)]

	bbox = sprite.get_bbox()
	
	for i in range(5):
		x = bbox[i][0] + sprite.x
		y = bbox[i][1] + sprite.y
		surf = pygame.Surface((bbox[i][2], bbox[i][3]), SRCALPHA)
		surf.fill(colors[i])
		screen.blit(surf, pygame.Rect(x, y, bbox[i][2], bbox[i][3]))
