#!/bin/env python
import pygame, sys, time, random
sys.path.append('game/')
import menu, util
from gelarena import *
from sprite import *
from moves import *
from keys import *
from util import *
from Numeric import *
from pygame.locals import *

random.seed(time.time())

bg_music = ['protofunk.ogg', 'guitonsketch.ogg', 'exotics.ogg', 'feelinggood.ogg', 'stylefunk.ogg']

bg_base = ["bridge", "castle", "china", "desert", "goza", "hollywood", "light_house", "rome", "wind_mill"]
bg_mod = ["", "2", "3", "4", "5"]

BLACK = pygame.Color(0,0,0, 192)
TRANSPARENT = pygame.Color(0,0,0, 0)
RED = pygame.Color(255,0,0, 192)
BLUE = pygame.Color(0,0,255, 192)

pygame.mixer.pre_init(44100)
pygame.init()
	
	
size = width, height = 640, 480
screen = pygame.display.set_mode(size)

bars = pygame.Surface((202, 45), SRCALPHA)

while 1:
	options = menu.do_menu(screen)
	
	KEY_STATE = KeyState()
	played = 0
	if options[3] == 1:
		played = 1
		player1 = Sprite(pygame.image.load("images/" + options[0] + ".png"), open("data/default.bbox", "r"), create_moves(options[0]))
		player2 = Sprite(pygame.image.load("images/" + options[1] + ".png"), open("data/default.bbox", "r"), create_moves(options[1]))
		player1.moveto(96, 240 - 64)
		player2.moveto(640-96-64, 240 - 64)
		players = pygame.sprite.RenderPlain(player1, player2)
	
		arena = GelArena(pygame.image.load("images/" + random.choice(bg_base) + random.choice(bg_mod) +".png"))
		bg = arena.bg

		pygame.mixer.music.load('sounds/' + random.choice(bg_music))
		pygame.mixer.music.play(-1)

	ok = 1
	winner = "noone"
	win_flavor = options[2]

	if options[3] == 2: ok = 0
	
	start = time.time()
	while ok:
		for event in pygame.event.get():
			if event.type == pygame.QUIT: sys.exit()
			else: KEY_STATE.update(event)
		
		tmp = time.time()
		
		
		update_sprites([player1, player2], [KEY_STATE.player1_queue, KEY_STATE.player2_queue], [KEY_STATE.player1_state, KEY_STATE.player2_state], (tmp-start)*1.0, arena)

		bgcopy = bg.copy()
		arena.bg = bgcopy

		bars.fill(BLACK)
		bars.fill(TRANSPARENT, pygame.Rect(0, 22, 202, 1))
		bars.fill(RED, pygame.Rect(1, 1, 2*player1.stats.health, 20))
		bars.fill(BLUE, pygame.Rect(1, 24, 2*player1.stats.balance, 20))
		bgcopy.blit(bars, Rect(55, 55, 202, 45))

		bars.fill(BLACK)
		bars.fill(TRANSPARENT, pygame.Rect(0, 22, 202, 1))
		bars.fill(RED, pygame.Rect(1, 1, 2*player2.stats.health, 20))
		bars.fill(BLUE, pygame.Rect(1, 24, 2*player2.stats.balance, 20))
		bgcopy.blit(bars, Rect(640-55-202, 55, 202, 45))

		arena.bg_blit(screen)
	
		players.draw(screen)
	
		util.draw_bboxes(screen, player1)
		util.draw_bboxes(screen, player2)

		pygame.display.flip()
		
		start = tmp
		
		if player1.stats.health <= 0 or player2.stats.health <= 0:
			ok = 0
			if player1.stats.health <= 0 and player2.stats.health <= 0:
				winner = "noone"
				win_flavor = options[2]
				y1 = 440 - 64
				y2 = 440 - 64
				player1.stats.balance = -100
				player2.stats.balance = -100
			elif player1.stats.health <= 0:
				winner = "player2"
				win_flavor = options[1]
				y1 = 440 - 64
				y2 = 138 - 64
				player1.stats.balance = 100
				player2.stats.balance = 100
			else:
				winner = "player1"
				win_flavor = options[0]
				y2 = 440 - 64
				y1 = 138 - 64
				player2.stats.balance = -100
				player1.stats.balance = 100
			
	
	util.fadeout(screen, 1.0)
	
	pygame.mixer.music.load('sounds/finalcount.ogg')
	pygame.mixer.music.play(-1)
	
	ending = pygame.image.load("images/victory_" + winner + "_" + win_flavor + ".png")
	screen.blit(ending, pygame.Rect(0, 0, 640, 480))
	
	util.fadein(screen, 1.0)
	
	pygame.event.pump()

	if played:
		player1.moveto(120, y1)
		player2.moveto(440, y2)
	
	ok = 1
	start = time.time()
	while ok:
		for event in pygame.event.get():
			if event.type == pygame.QUIT: sys.exit()
			if event.type == pygame.KEYDOWN: ok = 0
		
		screen.blit(ending, pygame.Rect(0, 0, 640, 480))	
		if played:
			tmp = time.time()
		
			player1.vely = player1.accely = 0
			player1.velx = player1.accelx = 0
			player2.vely = player2.accely = 0
			player2.velx = player2.accelx = 0

			if player1.stats.balance < 0: player1.stats.balance = -100
			if player2.stats.balance < 0: player2.stats.balance = -100

			player1.update([], [0,0,0,0,0,0], (tmp-start)*1.0, 440)
			player2.update([], [0,0,0,0,0,0], (tmp-start)*1.0, 120)
	
			start = tmp
		
			players.draw(screen)
		pygame.display.flip()
	
	
